#include "iot.h"
#include "uart.h"
#include <string.h>


const char ATStrDoiot[] = "doiot";
const char ATStrAT[] = "AT\r\n";
const char ATStrATOK[] = "\r\nOK\r\n";
const char ATStrATI[] = "ATI\r\n";
const char ATStrCCID[] = "AT+ICCID\r\n";
const char ATStrCreg[] = "AT+CEREG?\r\n";
const char ATStrCSQ[] = "AT+CSQ\r\n";
const char ATStrZIPCFG[] = "AT+ZIPCFG=CMIOTQPCAR.JS,none,none\r\n";
const char ATStrZIPCALL[] = "AT+ZIPCALL=1\r\n";
const char ATStrZIPCALLAns[] = "AT+ZIPCALL?\r\n";
const char ATStrZIPSTAT[] = "AT+ZIPSTAT=1\r\n";
const char ATStrZIPOPEN[] = "AT+ZIPOPEN=1,0,122.114.122.174,42626\r\n";
const char ATStrZIPCLOSE[] = "AT+ZIPCLOSE=1\r\n";


extern uint16_t LED_Num;																											// δӷ200OneNET1000


uint8_t TCPConnectStatus = 0;																									// TCP״̬0δӣ1
uint8_t IOT_Rssi = 0;																													// źǿ
	
void IOT_Init(void)																														// ģʼ
{
	uint8_t initStep = 0;																												// ʼ
	uint8_t sendReturn = 0;																											// ķֵ0ʧܣ1ɹ
	
	while(1)
	{
		HAL_IWDG_Refresh(&hiwdg);																									// Źι
		switch(initStep)
		{
			case 0:																																	// ATģʽ
				TCPConnectStatus = 0;																								  // ״̬
				sendReturn = IOT_intoATMethod();																			// 1˵ATģʽ				
				if(sendReturn != 1)																										// δʶAT˵ûп
				{
					sendReturn = IOT_PWR(1);																						// ɹ1ʧܷ0
				}
				break;
			case 1:						
				sendReturn = IOT_sendAT(ATStrATI, 1000);															// ATIģͺš汾šIMEI
				break;
			case 2:
				sendReturn = IOT_sendAT(ATStrCCID, 1000);															// AT+ICCIDICCID
				break;
			case 3:
				sendReturn = IOT_sendAT(ATStrCreg, 1000);															// AT+CEREGע״̬
				break;
			case 4:
				sendReturn = IOT_sendAT(ATStrCSQ, 1000);															// AT+CSQźǿ			
				break;
			case 5:
				sendReturn = IOT_sendAT(ATStrZIPCFG, 1000);														// AT+IPCFGAPN
				break;
			case 6:								 
				sendReturn = IOT_sendAT(ATStrZIPCALLAns, 10000);											// AT+ZIPCALL?
				if(sendReturn != 1)
				{
					sendReturn = IOT_sendAT(ATStrZIPCALL, 30000);												// AT+ZIPCALL=1
				}
				break;
			case 7:
				sendReturn = IOT_sendAT(ATStrZIPOPEN, 10000);													// AT+ZIPOPENTCP
				if(sendReturn == 2)
				{
					IOT_sendAT(ATStrZIPCLOSE, 1000);																		// ȴɹ
				}
				break;
			default:
				break;
		}		
		if(sendReturn == 1)																												// ɹʶһ
		{
			initStep++;																															// в+1			
			HAL_Delay(500);			
		}
		else
		{
			HAL_Delay(1000);
		}
				
		UART2_SendCharStr("LOG:IOT_Init->initStep:");														
		UART2_SendData(initStep);								
		UART2_SendCharStr("\r\n");						
		
		if(initStep == 8)																													// ӷɹ
		{
			TCPConnectStatus = 1;																										// TCPӳɹ		
			LED_Num = 1000;
			UART2_SendCharStr("LOG:IOT_Init->Connect Server OK\r\n");								// ӡӳɹʾ			
			HAL_GPIO_WritePin(doLED_GPIO_Port, doLED_Pin, GPIO_PIN_SET);						// LED	
			break;
		}
	}	
}

// ܣػIOTģ顣mode 10ػ
// ɹأ1ʧܷأ0
uint8_t IOT_PWR(uint8_t mode)																									
{
	uint8_t i=0;
	uint8_t sendReturn = 0;																											// ֵ
	
	HAL_GPIO_WritePin(doPOWER_GPIO_Port, doPOWER_Pin, GPIO_PIN_SET);						
	if(mode == 1)
	{		
		HAL_Delay(1000);																													// 1s
	}
	else if(mode == 0)
	{		
		HAL_Delay(4000);																													// ػ4s
	}																																		
	HAL_IWDG_Refresh(&hiwdg);																										// ι
	HAL_GPIO_WritePin(doPOWER_GPIO_Port, doPOWER_Pin, GPIO_PIN_RESET);					// 
	if(mode == 1)
	{		
		HAL_Delay(8000);																													// ȴ8s
	}
	else if(mode == 0)
	{		
		HAL_Delay(15000);																													// ػȴ15s
	}
	HAL_IWDG_Refresh(&hiwdg);																										// ι
	
	if(mode == 1)																																// ҪȴATͨ
	{
		for(i=0; i<30; i++)																												// 35sATͨ
		{
			HAL_IWDG_Refresh(&hiwdg);																								// ι
			sendReturn = IOT_sendAT(ATStrAT, 1000);																	// ATOK˵ͨ
			if(sendReturn == 1)																											// ʶɹ
			{
				break;
			}
		}		
	}
	else
	{
		sendReturn = 1;																														// ػҪжϷֵ
	}
	
	if(mode == 1)
	{
		UART2_SendCharStr("LOG:IOT_PWR->i:");														
		UART2_SendData(sendReturn);
		UART2_SendCharStr("\r\n");
		UART2_SendCharStr("LOG:IOT_PWR->PowerOn\r\n");																			// ӡʾ
	}
	else
	{
		UART2_SendCharStr("LOG:IOT_PWR->PowerOff\r\n");																			// ӡػʾ
	}
	
	return sendReturn;
}


uint8_t IOT_intoATMethod(void)																								// ѯAT
{
	uint8_t sendReturn = 0;																											// ֵ
	uint8_t i = 0;																															// ѭֵ
	
	for(i=0; i<3; i++)
	{
		sendReturn = IOT_sendAT(ATStrAT, 1000);																		// ATOK˵ͨ
		if(sendReturn ==1)																												// Աȳɹ
		{			
			break;
		}
	}	
	
	return sendReturn;
}

void IOT_HeartMethod(void)																									// 
{
	UART1_SendCharStr("AT+ZIPSEND=1,C000\r\n");
	UART2_SendCharStr("IOT_HeartMethod\r\n");
}
