#include "uart.h"
#include <string.h>
#include "time.h"
#include "sys.h"
#include "iot.h"

extern UART_HandleTypeDef huart1;
extern UART_HandleTypeDef huart2;

extern TIM_HandleTypeDef htim1;
extern TIM_HandleTypeDef htim2;

uint8_t UART1_RxMaxNum = 255;																																				// 1󳤶
uint8_t UART1_Buf[255];																																							// 1飬UART1_RxBufMaxNumֽ
uint8_t UART1_Mark = 0;																																							// 1յݱ־
uint8_t UART1_RxCplt = 0;																																						// 1ɱ־λ
uint8_t UART1_RxNum = 0;																																						// 1յĸ
uint8_t UART1_Once = 0;																																							// 0һνյݣ1ǵһ			
uint8_t UART1_OnceRxNum = 0;																																				// ϴνյĸ

uint8_t UART2_RxMaxNum = 255;																																				// 2󳤶
uint8_t UART2_Buf[255];																																							// 2飬UART2_RxBufMaxNumֽ
uint8_t UART2_Mark = 0;																																							// 2յݱ־
uint8_t UART2_RxCplt = 0;																																						// 2ɱ־λ
uint8_t UART2_RxNum = 0;																																						// 2յĸ
uint8_t UART2_Once = 0;																																							// 0һνյݣ1ǵһ			
uint8_t UART2_OnceRxNum = 0;																																				// ϴνյĸ


void UART1_Send(uint8_t *str)																																				// 1ͺ
{
	while(HAL_UART_Transmit_IT(&huart1, str, strlen((char*)str)) != HAL_OK);													// жϷ
}

void UART1_SendCharStr(char *str)																																		// 2ͺ
{
	while(HAL_UART_Transmit_IT(&huart1, (uint8_t*)str, strlen(str)) != HAL_OK);												// жϷ
}

void UART2_Send(uint8_t *str)																																				// 1ͺ
{
	while(HAL_UART_Transmit_IT(&huart2, str, strlen((char*)str)) != HAL_OK);													// жϷ
}

void UART1_SendConst(const char *str)																																// 2ͺ
{
	while(HAL_UART_Transmit_IT(&huart1, (uint8_t*)str, strlen((char*)str)) != HAL_OK);								// жϷ
}

void UART2_SendCharStr(char *str)																																		// 2ͺ
{
	while(HAL_UART_Transmit_IT(&huart2, (uint8_t*)str, strlen(str)) != HAL_OK);												// жϷ
}

void UART2_SendData(uint8_t data)																																		// 1͵ֵ
{
	uint8_t str[3] = "000";
	
	str[2] = data % 10 + '0';																																					// ֵתΪַ
	str[1] = data % 100 / 10 + '0';																																		// ֵתΪַ
	str[0] = data / 100 + '0';																																				// ֵתΪַ
	HAL_Delay(10);
	while(HAL_UART_Transmit_IT(&huart2, (uint8_t*)str, 3) != HAL_OK);																// жϷ
	HAL_Delay(10);
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)																							// ڽɵĻص
{
	if(huart->Instance == USART1)																																			// ȷǴ1
	{
		if(UART1_Once == 1)																																							// ǵһνյ
		{
			UART1_Buf[0] = UART1_Buf[UART1_OnceRxNum];																										// յĵһݷַ[0]λ
			UART1_Once = 0;
		}	
		if(UART1_RxNum < (UART1_RxMaxNum-1))																														// յֵûг˴1ֵ򴢴浽
		{
			UART1_RxNum++;																																								// 1յĸ		
		}		
		while(HAL_UART_Receive_IT(&huart1, (uint8_t*)&UART1_Buf[UART1_RxNum], 1) != HAL_OK);						// 1һνж					
		Timer1_Num = 0;																																									// Timer6ֵ֤ݵʱʱᳬʱ
		UART1_Mark = 1;																																									// 1յݱ־
	}
	else if(huart->Instance == USART2)																																// ȷǴ1
	{
		if(UART2_Once == 1)																																							// ǵһνյ
		{
			UART2_Buf[0] = UART2_Buf[UART2_OnceRxNum];																										// յĵһݷַ[0]λ
			UART2_Once = 0;
		}	
		if(UART2_RxNum < (UART2_RxMaxNum-1))																														// յֵûг˴1ֵ򴢴浽
		{
			UART2_RxNum++;																																								// 1յĸ		
		}		
		while(HAL_UART_Receive_IT(&huart2, (uint8_t*)&UART2_Buf[UART2_RxNum], 1) != HAL_OK);						// 1һνж					
		Timer2_Num = 0;																																									// Timer6ֵ֤ݵʱʱᳬʱ
		UART2_Mark = 1;																																									// 1յݱ־
	}
}

void UART1_RxMetohd(void)
{
	if(UART1_Mark == 1)																																								// 1յ
	{			
		if(HAL_TIM_Base_GetState(&htim1) != HAL_TIM_STATE_BUSY)																					// ʱ1ûд
		{
			HAL_TIM_Base_Start_IT(&htim1);																																// ʱ1
		}			
	}
	if(UART1_RxCplt == 1)																																							// 1																						
	{					
		if(UART1_Once == 1)																																							// ǵһνյ
		{
			UART1_Buf[0] = UART1_Buf[UART1_RxNum];
		}
		UART1_RxMetohdHandle();		
		HAL_TIM_Base_Stop_IT(&htim1);																																		// رնʱ1
		Timer1_Num = 0;																																									// Timer1ֵ
		UART1_OnceRxNum = UART1_RxNum;																																	// סεĽո´νմ
		UART1_RxNum = 0;																																								// 㴮1յĸ			
		UART1_Mark = 0;   																																							// 㴮1ձ־
		UART1_RxCplt = 0;																																								// 㴮1־	
		UART1_Once = 1;																																									// 趨Ϊǵһνյ
	}
}

void UART2_RxMetohd(void)
{
	if(UART2_Mark == 1)																																								// 2յ
	{			
		if(HAL_TIM_Base_GetState(&htim2) != HAL_TIM_STATE_BUSY)																					// ʱ2ûд
		{
			HAL_TIM_Base_Start_IT(&htim2);																																// ʱ2
		}			
	}
	if(UART2_RxCplt == 1)																																							// 2																						
	{							
		if(UART2_Once == 1)																																							// ǵһνյ
		{
			UART2_Buf[0] = UART2_Buf[UART2_RxNum];
		}
		UART2_RxMetohdHandle();		
		HAL_TIM_Base_Stop_IT(&htim2);																																		// رնʱ2
		Timer2_Num = 0;																																									// Timer2ֵ
		UART2_OnceRxNum = UART2_RxNum;																																	// סεĽո´νմ
		UART2_RxNum = 0;																																								// 㴮2յĸ			
		UART2_Mark = 0;   																																							// 㴮2ձ־
		UART2_RxCplt = 0;																																								// 㴮2־	
		UART2_Once = 1;																																									// 趨Ϊǵһνյ
	}
}

uint8_t GetLocation(void)
{
	uint8_t i,j=0;
	
	for(i=0; i<UART1_RxNum; i++)
	{
		if(UART1_Buf[i] == ',')
		{
			j++;
		}
		if(j == 4)																																											// жϵ4,
		{
//			UART2_SendData(i);
//			UART2_SendCharStr("\r\n");
			return i;
		}
	}
	
	return 0;
}


void UART1_RxMetohdHandle(void)																																			// 1
{		
	UART2_SendCharStr("LOG:UART1_RxMetohdHandle->\r\n");
	while(HAL_UART_Transmit_IT(&huart2, (uint8_t *)UART1_Buf, UART1_RxNum) != HAL_OK);								// ڴ2ϣӡյ				
	UART2_SendCharStr("<-\r\n");
	
	if((UART1_Buf[2]=='+') && (UART1_Buf[3]=='Z') && (UART1_Buf[4]=='I') && (UART1_Buf[5]=='P')
		 && (UART1_Buf[6]=='S') && (UART1_Buf[7]=='T') && (UART1_Buf[8]=='A') && (UART1_Buf[9]=='T')
		 && (UART1_Buf[14]=='0'))
	{
		UART2_SendCharStr("LOG:TCP ERROR\r\n");
		TCPConnectStatus = 0;
	}		
	else if((UART1_Buf[2]=='+') && (UART1_Buf[3]=='Z') && (UART1_Buf[4]=='I') && (UART1_Buf[5]=='P')
		 && (UART1_Buf[6]=='R') && (UART1_Buf[7]=='E') && (UART1_Buf[8]=='C') && (UART1_Buf[9]=='V'))
	{
		while(HAL_UART_Transmit_IT(&huart2, (uint8_t *)UART1_Buf+GetLocation()+1, UART1_RxNum-GetLocation()-2) != HAL_OK);								// ڴ1ϣӡյ	
	}	
}

void UART2_RxMetohdHandle(void)																																			// 2
{		
	char ATStrZIPSENDRAW[] = "AT+ZIPSENDRAW=1,000,5\r\n";
	
	UART2_SendCharStr("LOG:UART2_RxMetohdHandle->\r\n");
	while(HAL_UART_Transmit_IT(&huart2, (uint8_t *)UART2_Buf, UART2_RxNum) != HAL_OK);								// ڴ1ϣӡյ	
	UART2_SendCharStr("<-\r\n");	
	
	ATStrZIPSENDRAW[16] = UART2_RxNum/100+'0';
	ATStrZIPSENDRAW[17] = UART2_RxNum%100/10+'0';
	ATStrZIPSENDRAW[18] = UART2_RxNum%10+'0';
	UART1_SendCharStr(ATStrZIPSENDRAW);
	HAL_Delay(10);
	while(HAL_UART_Transmit_IT(&huart1, (uint8_t *)UART2_Buf, UART2_RxNum) != HAL_OK);								// ڴ1ϣӡյ	
}


uint8_t IOT_sendAT(const char* AT, uint16_t timeOut)																								// ܣģ鷢ATָ
{
	uint32_t Start_Time;																																							// ʱ	
	uint8_t sendReturn = 0;																																						// ֵ

	if(strcmp(ATStrDoiot, AT) != 0)																																		// Ҫ
	{
		UART1_SendConst(AT);																																						// ATָ																												
	}	
	Start_Time = HAL_GetTick();																																				// ȡʱ
	while(1)
	{
		HAL_IWDG_Refresh(&hiwdg);																																				// Źι
		sendReturn = UART1_Handle_Const(AT);																														// 2
		if(sendReturn != 0)																																							// յݣҶԱ
		{
			return sendReturn;
		}
		if((HAL_GetTick() - Start_Time) > timeOut)																											// ʱ
		{
			return 0;																																											// ˳ѭʶʧܵı־
		}
	}
}

uint8_t UART1_Handle_Const(const char* AT)																													// AT2մ
{
	uint8_t sendReturn = 0;																																				// ֵ
	
	if(UART1_Mark == 1)																																								// 2յ
	{			
		if(HAL_TIM_Base_GetState(&htim1) != HAL_TIM_STATE_BUSY)																					// ʱ2ûд
		{
			HAL_TIM_Base_Start_IT(&htim1);																																// ʱ2
		}			
	}
	if(UART1_RxCplt == 1)																																							// 2																						
	{					
		if(UART1_Once == 1)																																							// ǵһνյ
		{
			UART1_Buf[0] = UART1_Buf[UART1_RxNum];
		}
		
		UART2_SendCharStr("LOG:UART2_Handle_Const->");
		while(HAL_UART_Transmit_IT(&huart2, (uint8_t*)UART1_Buf, UART1_RxNum) != HAL_OK);								// յͨ1ͳȥ
		UART2_SendCharStr("<-\r\n");

		if(strcmp(AT, ATStrAT) == 0)																																		// AT
		{
			if((strncmp((char*)UART1_Buf, (char*)ATStrATOK, UART1_RxNum) == 0))														// ȶԳɹ
			{
				UART2_SendCharStr("LOG:AT OK\r\n");
				sendReturn = 1;																																							// 1
			}	
		}
		else if((strcmp(AT, ATStrATI) == 0) || (strcmp(AT, ATStrCCID) == 0) || (strcmp(AT, ATStrCSQ) == 0)
			 || (strcmp(AT, ATStrZIPCFG) == 0))																														// ATIICCIDCSQZIPCFG
		{			
			UART2_SendCharStr("LOG:ATI/ICCID/CSQ/ZIPCFG OK\r\n");
			sendReturn = 1;																																								// 1		
		}
		else if(strcmp(AT, ATStrCreg) == 0)																															// AT+CEREG
		{
			if(UART1_Buf[11]==',')
			{
				if((UART1_Buf[12]=='1') || (UART1_Buf[12]=='4') || (UART1_Buf[12]=='5'))
				{
					UART2_SendCharStr("LOG:CEREG OK\r\n");
					sendReturn = 1;																																						// 1
				}				
			}
		}
		else if(strcmp(AT, ATStrZIPCALL) == 0)																													// AT+ZIPCALL
		{
			if(UART1_Buf[18]=='1')																																					// ֱӷOK+IPַ
			{				
				UART2_SendCharStr("LOG:ZIPCALL OK1\r\n");																									
				sendReturn = 1;																																							// 1								
			}
			else if((UART1_Buf[2]=='O') && (UART1_Buf[3]=='K'))																						// ֻOK
			{				
				UART2_SendCharStr("LOG:ZIPCALL OK2\r\n");
				sendReturn = 2;																																							// 1								
			}
		}
//		else if(strcmp(AT, ATStrDoiot) == 0)																														// AT+ZIPCALL
//		{
//			if(UART1_Buf[14]=='1')
//			{				
//				UART2_SendCharStr("LOG:ZIPOPEN OK\r\n");
//				sendReturn = 1;																																							// 1								
//			}
//		}
		else if(strcmp(AT, ATStrZIPCALLAns) == 0)																												// AT+ZIPCALL?
		{
			if(UART1_Buf[12]!='0')
			{				
				UART2_SendCharStr("LOG:ATStrZIPCALLOK OK\r\n");
				sendReturn = 1;																																							// 1								
			}
		}		
		else if(strcmp(AT, ATStrZIPSTAT) == 0)																													// AT+ZIPCALL
		{
			if(UART1_Buf[14]=='1')
			{				
				UART2_SendCharStr("LOG:ZIPSTAT OK\r\n");	
				sendReturn = 1;																																							// 1								
			}
		}
		else if(strcmp(AT, ATStrZIPOPEN) == 0)																													// AT+ZIPOPEN
		{
			if(UART1_Buf[20]=='1')
			{				
				UART2_SendCharStr("LOG:ATStrZIPOPEN OK\r\n");
				sendReturn = 1;																																							// 1								
			}
			else if((UART1_Buf[2]=='E') && (UART1_Buf[3]=='R') && (UART1_Buf[4]=='R') && (UART1_Buf[5]=='O') && (UART1_Buf[6]=='R'))				
			{				
				sendReturn = 2;																																							// 1								
			}
		}	
						
		HAL_TIM_Base_Stop_IT(&htim1);																																		// رնʱ2
		Timer1_Num = 0;																																									// Timer2ֵ
		UART1_OnceRxNum = UART1_RxNum;																																	// סεĽո´νմ
		UART1_RxNum = 0;																																								// 㴮2յĸ			
		UART1_Mark = 0;   																																							// 㴮2ձ־
		UART1_RxCplt = 0;																																								// 㴮2־	
		UART1_Once = 1;																																									// 趨Ϊǵһνյ
	}
	
	return sendReturn;
}
